#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

typedef unsigned int SOCKET;
const unsigned int INVALID_SOCKET=0xffffffff;

int MNetHttpGet(char *hostname, unsigned int hostip, unsigned short int port, char *file, char *doc, int *docn)
{
	SOCKET sock;
	
	sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	if (INVALID_SOCKET==sock)
		return 1;
		
	sockaddr_in addrremote;		
	memset(&addrremote,0,sizeof(sockaddr_in));
	addrremote.sin_addr.s_addr=hostip;
	addrremote.sin_family=AF_INET;
	addrremote.sin_port=htons(port);

	if (0!=connect(sock,(sockaddr*)&addrremote,sizeof(sockaddr_in)))
		return 2;	
	
	char p[1024*16];
	int pn;
	sprintf(p,"GET %s HTTP/1.1\nAccept: */*\nUser-Agent: Mozilla/4.0 (compatible; MNetHttpGet)\nHost: %s\n\n",
		file,hostname
		);
	pn=strlen(p);
	
	//printf(p);
	
	send(sock,p,pn,MSG_NOSIGNAL);
	usleep(1000000*10);
	pn=16*1024-1;
	pn=recv(sock,p,pn,MSG_NOSIGNAL);
	close(sock);

	//p[pn]=0;
	//printf(p);

	char needle[5]={13,10,13,10,0};
	char *d=strstr(p,needle);
	if (d==0)
	{
		*docn=0;
	}
	else
	{
		d+=4;
		*docn=pn-(d-p);
		memcpy(doc,d,pn-(d-p));
	}
	
	return 0;
}
